/* This program is Copyright © 2013-2015 Charo I. Del Genio */

/* Licensed under the Academic Free License version 3.0

1) Grant of Copyright License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, for the duration of the copyright,
   to do the following:
    a) to reproduce the Original Work in copies, either alone or as part
       of a collective work;
    b) to translate, adapt, alter, transform, modify, or arrange the Original
       Work, thereby creating derivative works ("Derivative Works") based
       upon the Original Work;
    c) to distribute or communicate copies of the Original Work and
       Derivative Works to the public, under any license of your choice that
       does not contradict the terms and conditions, including Licensor's
       reserved rights and remedies, in this Academic Free License;
    d) to perform the Original Work publicly; and
    e) to display the Original Work publicly.

2) Grant of Patent License. Licensor grants You a worldwide, royalty-free,
   non-exclusive, sublicensable license, under patent claims owned or
   controlled by the Licensor that are embodied in the Original Work as
   furnished by the Licensor, for the duration of the patents, to make, use,
   sell, offer for sale, have made, and import the Original Work and
   Derivative Works.

3) Grant of Source Code License. The term "Source Code" means the preferred
   form of the Original Work for making modifications to it and all available
   documentation describing how to modify
   the Original Work. Licensor agrees to provide a machine-readable copy of
   the Source Code of the Original Work along with each copy of the Original
   Work that Licensor distributes. Licensor reserves the right to satisfy
   this obligation by placing a machine-readable copy of the Source Code in
   an information repository reasonably calculated to permit inexpensive
   and convenient access by You for as long as Licensor continues to
   distribute the Original Work.

4) Exclusions From License Grant. Neither the names of Licensor, nor the names
   of any contributors to the Original Work, nor any of their trademarks or
   service marks, may be used to endorse or promote products derived from this
   Original Work without express prior permission of the Licensor. Except as
   expressly stated herein, nothing in this License grants any license to
   Licensor's trademarks, copyrights, patents, trade secrets or any other
   intellectual property. No patent license is granted to make, use, sell,
   offer for sale, have made, or import embodiments of any patent claims other
   than the licensed claims defined in Section 2. No license is granted to the
   trademarks of Licensor even if such marks are included in the Original Work.
   Nothing in this License shall be interpreted to prohibit Licensor from
   licensing under terms different from this License any Original Work that
   Licensor otherwise would have a right to license.

5) External Deployment. The term "External Deployment" means the use,
   distribution, or communication of the Original Work or Derivative Works in
   any way such that the Original Work or Derivative Works may be used by
   anyone other than You, whether those works are distributed or communicated
   to those persons or made available as an application intended for use over
   a network. As an express condition for the grants of license hereunder, You
   must treat any External Deployment by You of the Original Work or a
   Derivative Work as a distribution under section 1(c).

6) Attribution Rights. You must retain, in the Source Code of any Derivative
   Works that You create, all copyright, patent, or trademark notices from the
   Source Code of the Original Work, as well as any notices of licensing and
   any descriptive text identified therein as an "Attribution Notice." You
   must cause the Source Code for any Derivative Works that You create to
   carry a prominent Attribution Notice reasonably calculated to inform
   recipients that You have modified the Original Work.

7) Warranty of Provenance and Disclaimer of Warranty. Licensor warrants that
   the copyright in and to the Original Work and the patent rights granted
   herein by Licensor are owned by the Licensor or are sublicensed to You
   under the terms of this License with the permission of the contributor(s)
   of those copyrights and patent rights. Except as expressly stated in the
   immediately preceding sentence, the Original Work is provided under this
   License on an "AS IS" BASIS and WITHOUT WARRANTY, either express or
   implied, including, without limitation, the warranties of non-infringement,
   merchantability or fitness for a particular purpose. THE ENTIRE RISK AS TO
   THE QUALITY OF THE ORIGINAL WORK IS WITH YOU. This DISCLAIMER OF WARRANTY
   constitutes an essential part of this License. No license to the Original
   Work is granted by this License except under this disclaimer.

8) Limitation of Liability. Under no circumstances and under no legal theory,
   whether in tort (including negligence), contract, or otherwise, shall the
   Licensor be liable to anyone for any indirect, special, incidental, or
   consequential damages of any character arising as a result of this License
   or the use of the Original Work including, without limitation, damages for
   loss of goodwill, work stoppage, computer failure or malfunction, or any and
   all other commercial damages or losses. This limitation of liability shall
   not apply to the extent applicable law prohibits such limitation.

9) Acceptance and Termination. If, at any time, You expressly assented to this
   License, that assent indicates your clear and irrevocable acceptance of this
   License and all of its terms and conditions. If You distribute or
   communicate copies of the Original Work or a Derivative Work, You must make
   a reasonable effort under the circumstances to obtain the express assent of
   recipients to the terms of this License. This License conditions your rights
   to undertake the activities listed in Section 1, including your right to
   create Derivative Works based upon the Original Work, and doing so without
   honoring these terms and conditions is prohibited by copyright law and
   international treaty. Nothing in this License is intended to affect
   copyright exceptions and limitations (including "fair use" or "fair
   dealing"). This License shall terminate immediately and You may no longer
   exercise any of the rights granted to You by this License upon your failure
   to honor the conditions in Section 1(c).

10) Termination for Patent Action. This License shall terminate automatically
    and You may no longer exercise any of the rights granted to You by this
    License as of the date You commence an action, including a cross-claim or
    counterclaim, against Licensor or any licensee alleging that the Original
    Work infringes a patent. This termination provision shall not apply for an
    action alleging patent infringement by combinations of the Original Work
    with other software or hardware.

11) Jurisdiction, Venue and Governing Law. Any action or suit relating to this
    License may be brought only in the courts of a jurisdiction wherein the
    Licensor resides or in which Licensor conducts its primary business, and
    under the laws of that jurisdiction excluding its conflict-of-law
    provisions. The application of the United Nations Convention on Contracts
    for the International Sale of Goods is expressly excluded. Any use of the
    Original Work outside the scope of this License or after its termination
    shall be subject to the requirements and penalties of copyright or patent
    law in the appropriate jurisdiction. This section shall survive the
    termination of this License.

12) Attorneys' Fees. In any action to enforce the terms of this License or
    seeking damages relating thereto, the prevailing party shall be entitled to
    recover its costs and expenses, including, without limitation, reasonable
    attorneys' fees and costs incurred in connection with such action,
    including any appeal of such action. This section shall survive the
    termination of this License.

13) Miscellaneous. If any provision of this License is held to be
    unenforceable, such provision shall be reformed only to the extent
    necessary to make it enforceable.

14) Definition of "You" in This License. "You" throughout this License, whether
    in upper or lower case, means an individual or a legal entity exercising
    rights under, and complying with all of the terms of, this License. For
    legal entities, "You" includes any entity that controls, is controlled by,
    or is under common control with you. For purposes of this definition,
    "control" means (i) the power, direct or indirect, to cause the direction
    or management of such entity, whether by contract or otherwise, or (ii)
    ownership of fifty percent (50%) or more of the outstanding shares, or
    (iii) beneficial ownership of such entity.

15) Right to Use. You may use the Original Work in all ways not otherwise
    restricted or conditioned by this License or by law, and Licensor promises
    not to interfere with or be responsible for such uses by You.

16) Modification of This License. This License is Copyright © 2005 Lawrence
    Rosen. Permission is granted to copy, distribute, or communicate this
    License without modification. Nothing in this License permits You to modify
    this License as applied to the Original Work or to Derivative Works.
    However, You may modify the text of this License and copy, distribute or
    communicate your modified version (the "Modified License") and apply it to
    other original works of authorship subject to the following conditions: (i)
    You may not indicate in any way that your Modified License is the "Academic
    Free License" or "AFL" and you may not use those names in the name of your
    Modified License; (ii) You must replace the notice specified in the first
    paragraph above with the notice "Licensed under <insert your license name
    here>" or with a notice of your own that is not confusingly similar to the
    notice in this License; and (iii) You may not claim that your original
    works are open source software unless your Modified License has been
    approved by Open Source Initiative (OSI) and You comply with its license
    review and certification process.
*/




#include"JDMsampler.h"




/* If JDM is graphical, initializes the memory for the sampler; otherwise returns 0 */
int initjdm(long int **jdm, const int maxdegree, int **userseq, int *usernodes)
{
	int i, j, k;
	unsigned long int stubs;
	
	
	maxdeg = maxdegree;
	nums = malloc((maxdeg+1)*sizeof(long int));							// Allocate memory for vector with sizes of degree classes
	
	/* Test graphicality of JDM */
	if (!testjdm(jdm)) {												// If JDM is not graphical
		free(nums);														// free the memory used
		return 0;														// and return 0;
	}
	
	/* Count the total number of nodes */
	nodes = 0;															// Otherwise
	for (i=1; i<=maxdeg; i++) nodes += nums[i];							// Count the total number of nodes
	*usernodes = nodes;
	
	/* Allocate memory */
	start             = malloc((maxdeg+2)*sizeof(int));					// Starting indices for degree classes
	smallm            = malloc((maxdeg+1)*sizeof(int));					// Vector of m
	bigm              = malloc((maxdeg+1)*sizeof(int));					// Vector of M
	seq               = malloc(nodes*sizeof(int));						// Degree sequence (sorted in NON-DECREASING order)
	*userseq          = malloc(nodes*sizeof(int));						// Sequence returned to the user
	auxseq            = malloc(nodes*sizeof(int));						// Auxiliary degree sequence used to find m and M
	auxseq2           = malloc(nodes*sizeof(int));						// Auxiliary degree sequence n. 2 used to find m and M
	auxbds            = malloc(nodes*sizeof(int*));						// Auxiliary bi-degree sequence used to find m and M
	auxbds[0]         = malloc(2*nodes*sizeof(int));
	auxbds2           = malloc(nodes*sizeof(int*));						// Auxiliary bi-degree sequence n. 2 used to find m and M
	auxbds2[0]        = malloc(2*nodes*sizeof(int));
	auxbds3.indegree  = malloc(nodes*sizeof(int));						// Auxiliary bi-degree sequence n. 3 (structure) used to build the final sample
	auxbds3.outdegree = malloc(nodes*sizeof(int));
	auxbds3.label     = malloc(nodes*sizeof(int));
	auxbds3.forbidden = calloc(nodes,sizeof(int));
	spectra           = malloc(nodes*sizeof(int*));						// Degree spectra
	spectra[0]        = malloc(nodes*(maxdeg+1)*sizeof(int));
	orijdm            = malloc((maxdeg+1)*sizeof(long int*));			// Original JDM
	orijdm[0]         = malloc((maxdeg+1)*(maxdeg+1)*sizeof(long int));
	resjdm            = malloc((maxdeg+1)*sizeof(long int*));			// Residual JDM
	resjdm[0]         = malloc((maxdeg+1)*(maxdeg+1)*sizeof(long int));
	for (i=1; i<=maxdeg; i++) {
		orijdm[i]  = orijdm[i-1] + maxdeg + 1;
		resjdm[i]  = resjdm[i-1] + maxdeg + 1;
		auxbds[i]  = auxbds[i-1]+2;
		auxbds2[i] = auxbds2[i-1]+2;
		spectra[i] = spectra[i-1]+ maxdeg + 1;
	}
	for (i=maxdeg+1; i<nodes; i++) {
		auxbds[i]  = auxbds[i-1]+2;
		auxbds2[i] = auxbds2[i-1]+2;
		spectra[i] = spectra[i-1]+ maxdeg + 1;
	}
	
	/* Create a backup copy of the JDM to be used in spectra extraction
	   and count the total number of stubs */
	stubs = 0;
	for (j=0; j<=maxdeg; j++) orijdm[0][j] = 0;
	for (i=1; i<=maxdeg; i++) {
		orijdm[i][0] = 0;
		for (j=1; j<=maxdeg; j++) {
			orijdm[i][j] = jdm[i-1][j-1];
			stubs += jdm[i-1][j-1];
		}
		stubs += jdm[i-1][i-1];
		orijdm[i][i] *= 2;
	}
	
	/* Create degree sequence and vector containing
	   the starting indices for degree classes. */
	start[0] = 0;
	j = 0;
	for (i=1; i<=maxdeg; i++) {
		start[i] = j;
		k = 0;
		while (k<nums[i]) {
			(*userseq)[j] = i;
			seq[j++] = i;
			k++;
		}
	}
	start[maxdeg+1] = j;
	
	/* Allocate memory for the sample. */
	sample.list    = malloc(nodes*sizeof(int*));
	sample.list[0] = calloc(stubs,sizeof(int));
	for (i=1; i<nodes; i++) sample.list[i] = sample.list[i-1] + seq[i-1];
	
	
	return 1;
}




/* Extract a set of degree spectra realizing the JDM */
double specsam(double (*rng)(void))
{
	int i, j, k, todo, allsize, ext;
	long int min, max, sumsm, sumbg;
	double weight=0;
	
	
	for (i=0; i<=maxdeg; i++) for (j=0; j<=maxdeg; j++) {
		resjdm[i][j] = orijdm[i][j];												// Make a copy of the original JDM into the residual JDM
		spectra[i][j] = 0;															// and initialize the degree spectra.
	}
	for (i=maxdeg+1; i<nodes; i++) for (j=0; j<=maxdeg; j++) spectra[i][j] = 0;
	
	for (i=0; i<nodes; i++) {														// For each node i
		todo = seq[i];																// Consider the stubs to allocate
		j = 1;																		// and all the degree classes j
		while (todo) {																// While there are still stubs to allocate,
			if (resjdm[seq[i]][j]) {												// if the JDM allows for edges between the class of i and j,
				k = j;																// then consider all the classes k, starting from j onwards.
				while (k<seq[i]) {													// For all such classes k less than the class of i,
					if (resjdm[seq[i]][k]) {										// if the JDM allows for edges between the class of i and k,
						smallm[k] = findsmlow(i,k);									// find the local limits m and M for k;
						bigm[k]   = findbglow(i,k,todo,smallm[k]);
					} else {														// otherwise, set m and M to 0.
						smallm[k] = 0;
						bigm[k]   = 0;
					}
					k++;
				}
				if (k==seq[i]) {													// If the next degree class is the degree class of i itself,
					if (resjdm[seq[i]][k]) {										// then, if the JDM allows for edges within the class of i,
						smallm[k] = findsmeq(i);									// find the local limits m and M for the class of i;
						bigm[k]   = findbgeq(i,todo,smallm[k]);
					} else {														// otherwise, set m and M to 0.
						smallm[k] = 0;
						bigm[k]   = 0;
					}
					k++;
				}
				while (k<=maxdeg) {													// For all the subsequent classes k,
					if (resjdm[seq[i]][k]) {										// if the JDM allows for edges between the class of i and k,
						smallm[k] = findsmhigh(i,k);								// find the local limits m and M for k;
						bigm[k]   = findbghigh(i,k,todo,smallm[k]);
					} else {														// otherwise, set m and M to 0.
						smallm[k] = 0;
						bigm[k]   = 0;
					}
					k++;
				}
				
				sumsm = sumbg = 0;													// Compute the sums of the lower and upper limits for the degree spectrum
				for (k=j+1; k<=maxdeg; k++) {										// for all the classes for which a choice has not yet been made.
					sumsm += smallm[k];
					sumbg += bigm[k];
				}
				
				min = (smallm[j]>=todo-sumbg ? smallm[j] : todo-sumbg);				// Find the ACTUAL minimum possible degree spectrum element for node i and class j
				max = (bigm[j]<=todo-sumsm ? bigm[j] : todo-sumsm);					// Find the ACTUAL maximum possible degree spectrum element for node i and class j
				allsize = max-min+1;
				weight += log(allsize);												// Update spectrum weight
				ext = allsize*rng()+min;											// Extract spectrum element
				spectra[i][j] = ext;												// Update degree spectra matrix
				resjdm[seq[i]][j] -= ext;											// Update residual joint degree matrix. Notice that for spectra extraction it is treated asymmetrically.
				todo -= ext;														// Update stubs of node i
			}
			j++;																	// Check next class
		}
	}
	
	
	return weight;
}




/* Sample the JDM */
graph jdmsam (double (*rng)(void), const int stfl)
{
	int i, j, k, index, stubflag;
	
	
	if (stfl) stubflag=1;																								// Determine whether user wants node sampling or stub sampling
	else stubflag=0;
	
	sample.weight = 0.0;																								// Initialize sample weight
	for (i=0; i<nodes; i++) auxseq2[i] = 0;																				// Initialize current node degrees
	
	for (i=1; i<=maxdeg; i++) {																							// For each degree class i
		if (orijdm[i][i]) {																								// If there are edges withing the degree class
			index = 0;
			for (k=start[i]; k<start[i+1]; k++) {																		// Create a bi-degree sequence in which the in-degrees are the spectrum
				auxbds[index][0] = spectra[k][i];																		// elements of the nodes in degree class i towards degree class i, and
				auxbds[index][1] = k;																					// the out-degrees are the actual labels of the nodes.
				index++;
			}
			lexqsort(auxbds,nums[i]);																					// Sort the bi-degree sequence lexicographically
			for (k=0; k<nums[i]; k++) auxseq[k] = auxbds[k][0];															// Extract the in-degrees and create an auxiliary degree sequence from them
			gsaminit(auxseq,nums[i]);																					// Initialize graph sampler
			auxgraph = gsam(rng,stubflag);																				// Sample a graph with the extracted degree sequence
			for (index=0; index<nums[i]; index++) for (k=0; k<auxseq[index]; k++) {										// Map the adjacency list of the sampled graph
				sample.list[auxbds[index][1]][auxseq2[auxbds[index][1]]] = auxbds[auxgraph.list[index][k]][1];			// into the adjacency list of the actual graph sample.
				auxseq2[auxbds[index][1]]++;
			}
			sample.weight += auxgraph.weight;																			// Update the sample weight
			gsamclean();																								// Clean the memory used by the sampler
		}
		for (j=i+1; j<=maxdeg; j++) {																					// For each degree class i greater than j
			if (orijdm[i][j]) {																							// If there are edges between i and j
				index = 0;
				for (k=start[i]; k<start[i+1]; k++) {																	// Create a bi-degree sequence composed of two parts:
					auxbds3.indegree[index]  = spectra[k][j];															// in the first part, the in-degrees are the spectrum
					auxbds3.outdegree[index] = 0;																		// elements of the nodes in class i towards class j,
					auxbds3.label[index]     = k;																		// while the out-degrees are 0;
					index++;
				}																										// in the second part, the in-degrees are 0,
				for (k=start[j]; k<start[j+1]; k++) {																	// while the out-degrees are the spectrum elements
					auxbds3.indegree[index]  = 0;																		// of the nodes in class j towards class i.
					auxbds3.outdegree[index] = spectra[k][i];															// For both parts, record the labels of the original nodes.
					auxbds3.label[index]     = k;
					index++;
				}
				lexbdsqsort(auxbds3,nums[i]+nums[j]);																	// Sort the bi-degree sequence lexicographically
				for (k=0; k<nums[i]+nums[j]; k++) {																		// Extract the degrees from the auxiliary bi-degree sequence structure
					auxbds[k][0] = auxbds3.indegree[k];
					auxbds[k][1] = auxbds3.outdegree[k];
				}
				digsaminit(auxbds,nums[i]+nums[j]);																		// Initialize directed graph sampler
				auxdigraph = digsam(rng,stubflag);																		// Sample a directed graph with the extracted bi-degree sequence
				/* Map the adjacency list of the sampled digraph into the adjacency list of the actual graph sample. */
				for (index=0; index<nums[i]+nums[j]; index++) for (k=0; k<auxbds[index][1]; k++) {
					sample.list[auxbds3.label[index]][auxseq2[auxbds3.label[index]]] = auxbds3.label[auxdigraph.list[index][k]];
					sample.list[auxbds3.label[auxdigraph.list[index][k]]][auxseq2[auxbds3.label[auxdigraph.list[index][k]]]] = auxbds3.label[index];
					auxseq2[auxbds3.label[index]]++;
					auxseq2[auxbds3.label[auxdigraph.list[index][k]]]++;
				}
				sample.weight += auxdigraph.weight;																		// Update the sample weight
				digsamclean();																							// Clean the memory used by the sampler
			}
		}
	}
	
	
	return sample;
}




/* Clean memory used */
void jdmclean(void)
{
	free(nums);
	free(start);
	free(smallm);
	free(bigm);
	free(seq);
	free(auxseq);
	free(auxseq2);
	free(auxbds[0]);
	free(auxbds);
	free(auxbds2[0]);
	free(auxbds2);
	free(auxbds3.indegree);
	free(auxbds3.outdegree);
	free(auxbds3.label);
	free(auxbds3.forbidden);
	free(spectra[0]);
	free(spectra);
	free(orijdm[0]);
	free(orijdm);
	free(resjdm[0]);
	free(resjdm);
	free(sample.list[0]);
	free(sample.list);
	
	
	return;
}




/* Find value of m for node node and class clto higher than that of node */
static int findsmhigh(const int node, const int clto)
{
	int i, j, m;
	
	
	for (i=0; i<nums[clto]; i++) {																					// Populate the first part of the auxiliary bi-degree sequence
		auxbds[i][0] = resjdm[clto][seq[node]]/nums[clto];															// with nodes having no out-degree. The in-degrees are chosen
		auxbds[i][1] = 0;																							// to balance the stubs yet to be assigned between the target
	}																												// class and the class of the node being considered.
	for (i=0; i<resjdm[clto][seq[node]]%nums[clto]; i++) auxbds[i][0]++;											// Notice that the JDM is treated asymmetrically for spectra extraction.
	
	j = nums[clto];																									// Populate the second part of the auxiliary bi-degree sequence
	for (i=start[seq[node]]; i<node; i++) {																			// with nodes having no in-degree. The out-degrees are determined
		auxbds[j][0] = 0;																							// by the already chosen degree spectra elements of the nodes
		auxbds[j][1] = spectra[i][clto];																			// in the same class as that of the node being considered.
		j++;
	}
	
	if (j==nums[seq[node]]+nums[clto]-1) m = resjdm[seq[node]][clto];												// If there is only one node left, the choice is forced.
	else {																											// Otherwise,
		m = -1;																										// systematically impose the out-degree m of the next node,
		do {																										// starting from 0,
			m++;
			auxbds[j][0] = 0;
			auxbds[j][1] = m;
			for (i=j+1; i<nums[seq[node]]+nums[clto]; i++) {														// balance the remaining stubs between the class of the node
				auxbds[i][0] = 0;																					// being considered and the target class amongst the remaining
				auxbds[i][1] = (resjdm[seq[node]][clto]-m)/(nums[seq[node]]+nums[clto]-j-1);						// nodes in the auxiliary bi-degree sequence.
			}
			for (i=j+1; i<j+1+(resjdm[seq[node]][clto]-m)%(nums[seq[node]]+nums[clto]-j-1); i++) auxbds[i][1]++;
			for (i=0; i<nums[seq[node]]+nums[clto]; i++) {															// Copy the bi-degree sequence into a second auxiliary bi-degree
				auxbds2[i][0] = auxbds[i][0];																		// sequence. This allows further tests to modify only the relevant
				auxbds2[i][1] = auxbds[i][1];																		// nodes in the first auxiliary bi-degree sequence, without having
			}																										// to rebuild it entirely because of the scrambling that comes next.
			lexqsort(auxbds2,nums[seq[node]]+nums[clto]);															// Sort the second auxiliary bi-degree sequence lexicographically
		} while (diGTest(auxbds2,nums[seq[node]]+nums[clto])!=1);													// and test it for graphicality. Repeat with a new choice
	}																												// of m until the test succeeds.
	
	
	return m;
}




/* Find value of m for node node and class clto lower than that of node */
static int findsmlow(const int node, const int clto)
{
	int i, j, m;
	
	
	j = 0;																											// Populate the first part of the auxiliary bi-degree sequence
	for (i=start[clto]; i<start[clto+1]; i++) {																		// with nodes having no out-degree. The in-degree are entirely
		auxbds[j][0] = spectra[i][seq[node]];																		// determined by the degree spectra elements of the nodes in the
		auxbds[j][1] = 0;																							// target class, all of which have already been chosen at this point.
		j++;
	}
	for (i=start[seq[node]]; i<node; i++) {																			// Populate the second part of the auxiliary bi-degree sequence
		auxbds[j][0] = 0;																							// with nodes having no in-degree. The out-degrees are determined
		auxbds[j][1] = spectra[i][clto];																			// by the already chosen degree spectra elements of the nodes
		j++;																										// in the same class as that of the node being considered.
	}
	
	if (j==nums[seq[node]]+nums[clto]-1) m = resjdm[seq[node]][clto];												// If there is only one node left, the choice is forced.
	else {																											// Otherwise, proceed as for findsmhigh (see the comments there).
		m = -1;
		do {
			m++;
			auxbds[j][0] = 0;
			auxbds[j][1] = m;
			for (i=j+1; i<nums[seq[node]]+nums[clto]; i++) {
				auxbds[i][0] = 0;
				auxbds[i][1] = (resjdm[seq[node]][clto]-m)/(nums[seq[node]]+nums[clto]-j-1);
			}
			for (i=j+1; i<j+1+(resjdm[seq[node]][clto]-m)%(nums[seq[node]]+nums[clto]-j-1); i++) auxbds[i][1]++;
			for (i=0; i<nums[seq[node]]+nums[clto]; i++) {
				auxbds2[i][0] = auxbds[i][0];
				auxbds2[i][1] = auxbds[i][1];
			}
			lexqsort(auxbds2,nums[seq[node]]+nums[clto]);
		} while (diGTest(auxbds2,nums[seq[node]]+nums[clto])!=1);
	}
	
	
	return m;
}




/* Find value of m for node node and its own class */
static int findsmeq(const int node)
{
	int i, j, m;
	
	
	j = 0;																											// Populate the first part of the auxiliary degree sequence
	for (i=start[seq[node]]; i<node; i++) {																			// with nodes whose degree is determined by the already chosen
		auxseq[j] = spectra[i][seq[node]];																			// degree spectra elements of the nodes in the same class as
		j++;																										// that of the node being considered.
	}
	
	if (j==nums[seq[node]]-1) m = resjdm[seq[node]][seq[node]];														// If there is only one node left, the choice is forced.
	else {																											// Otherwise,
		m = -1;																										// systematically impose the degree m of the next node,
		do {																										// starting from 0,
			m++;
			auxseq[j] = m;																							// balance the remaining stubs within the class of the node
			for (i=j+1; i<nums[seq[node]]; i++) auxseq[i]  = (resjdm[seq[node]][seq[node]]-m)/(nums[seq[node]]-j-1);// being considered amongst the remaining nodes in the auxiliary
			for (i=j+1; i<j+1+(resjdm[seq[node]][seq[node]]-m)%(nums[seq[node]]-j-1); i++) auxseq[i]++;				// degree sequence. Copy the degree sequence into a second auxiliary
			for (i=0; i<nums[seq[node]]; i++) auxseq2[i] = auxseq[i];												// degree sequence. Sort the second auxiliary degree sequence
			quicksort(auxseq2,nums[seq[node]]);																		// in non-increasing order and test it for graphicality. Repeat
		} while (GTest(auxseq2,nums[seq[node]])!=1);																// with a new choice of m until the test succeeds.
	}
	
	
	return m;
}




/* Find value of M for node node and its own class.
   The function works just like findsmeq. The only
   difference is that it does a binary search for
   the upper limit. The initial lower boundary is m,
   while the initial upper boundary is whichever is
   smaller between the residual stubs within the class
   of the node and the residual stubs on the node itself. */
static int findbgeq(const int node, const int left, const int small)
{
	int i, j, M, min, max;
	
	
	j = 0;
	for (i=start[seq[node]]; i<node; i++) {
		auxseq[j] = spectra[i][seq[node]];
		j++;
	}
	
	if (j==nums[seq[node]]-1) max = resjdm[seq[node]][seq[node]];
	else {
		min = small;
		max = (resjdm[seq[node]][seq[node]] < left ? resjdm[seq[node]][seq[node]] : left);
		while (min!=max) {
			M = ceil((min+max)/2.0);
			auxseq[j] = M;
			for (i=j+1; i<nums[seq[node]]; i++) auxseq[i]  = (resjdm[seq[node]][seq[node]]-M)/(nums[seq[node]]-j-1);
			for (i=j+1; i<j+1+(resjdm[seq[node]][seq[node]]-M)%(nums[seq[node]]-j-1); i++) auxseq[i]++;
			for (i=0; i<nums[seq[node]]; i++) auxseq2[i] = auxseq[i];
			quicksort(auxseq2,nums[seq[node]]);
			if (GTest(auxseq2,nums[seq[node]])==1) min = M;
			else max = M-1;
		}
	}
	
	
	return max;
}




/* Find value of M for node node and class clto lower than that of node.
   The function works just like findsmlow, but it does a binary search
   for the upper limit as described for findbgeq. See the comments there. */
static int findbglow(const int node, const int clto, const int left, const int small)
{
	int i, j, M, min, max;
	
	
	j = 0;
	for (i=start[clto]; i<start[clto+1]; i++) {
		auxbds[j][0] = spectra[i][seq[node]];
		auxbds[j][1] = 0;
		j++;
	}
	for (i=start[seq[node]]; i<node; i++) {
		auxbds[j][0] = 0;
		auxbds[j][1] = spectra[i][clto];
		j++;
	}
	
	if (j==nums[seq[node]]+nums[clto]-1) max = resjdm[seq[node]][clto];
	else {
		min = small;
		max = (resjdm[seq[node]][clto] < left ? resjdm[seq[node]][clto] : left);
		while (min!=max) {
			M = ceil((min+max)/2.0);
			auxbds[j][0] = 0;
			auxbds[j][1] = M;
			for (i=j+1; i<nums[seq[node]]+nums[clto]; i++) {
				auxbds[i][0] = 0;
				auxbds[i][1] = (resjdm[seq[node]][clto]-M)/(nums[seq[node]]+nums[clto]-j-1);
			}
			for (i=j+1; i<j+1+(resjdm[seq[node]][clto]-M)%(nums[seq[node]]+nums[clto]-j-1); i++) auxbds[i][1]++;
			for (i=0; i<nums[seq[node]]+nums[clto]; i++) {
				auxbds2[i][0] = auxbds[i][0];
				auxbds2[i][1] = auxbds[i][1];
			}
			lexqsort(auxbds2,nums[seq[node]]+nums[clto]);
			if (diGTest(auxbds2,nums[seq[node]]+nums[clto])==1) min = M;
			else max = M-1;
		}
	}
	
	
	return max;
}




/* Find value of M for node node and class clto higher than that of node
   The function works just like findsmhigh, but it does a binary search
   for the upper limit as described for findbgeq. See the comments there. */
static int findbghigh(const int node, const int clto, const int left, const int small)
{
	int i, j, M, min, max;
	
	
	for (i=0; i<nums[clto]; i++) {
		auxbds[i][0] = resjdm[clto][seq[node]]/nums[clto];
		auxbds[i][1] = 0;
	}
	for (i=0; i<resjdm[clto][seq[node]]%nums[clto]; i++) auxbds[i][0]++;
	
	j = nums[clto];
	for (i=start[seq[node]]; i<node; i++) {
		auxbds[j][0] = 0;
		auxbds[j][1] = spectra[i][clto];
		j++;
	}
	
	if (j==nums[seq[node]]+nums[clto]-1) max = resjdm[seq[node]][clto];
	else {
		min = small;
		max = (resjdm[seq[node]][clto] < left ? resjdm[seq[node]][clto] : left);
		while (min!=max) {
			M = ceil((min+max)/2.0);
			auxbds[j][0] = 0;
			auxbds[j][1] = M;
			for (i=j+1; i<nums[seq[node]]+nums[clto]; i++) {
				auxbds[i][0] = 0;
				auxbds[i][1] = (resjdm[seq[node]][clto]-M)/(nums[seq[node]]+nums[clto]-j-1);
			}
			for (i=j+1; i<j+1+(resjdm[seq[node]][clto]-M)%(nums[seq[node]]+nums[clto]-j-1); i++) auxbds[i][1]++;
			for (i=0; i<nums[seq[node]]+nums[clto]; i++) {
				auxbds2[i][0] = auxbds[i][0];
				auxbds2[i][1] = auxbds[i][1];
			}
			lexqsort(auxbds2,nums[seq[node]]+nums[clto]);
			if (diGTest(auxbds2,nums[seq[node]]+nums[clto])==1) min = M;
			else max = M-1;
		}
	}
	
	
	return max;
}




/* My efficient directed graphicality test */
static int diGTest(int **s, const int realn)
{
	int n, t, maxin, maxout, G[realn+1], S[realn+1];
	long int lhs=0, rhs=0, gtilde;
	
	
	t = realn;
	do t--;
	while (t>=0 && s[t][0]==0 && s[t][1]==0);
	n = t+1;
	
	if (n==0) return 1;
	
	maxin = s[t][0];
	if (maxin>=n) return -1;
	
	maxout = 0;
	for (t=0; t<n; t++) if (s[t][1]>maxout) maxout=s[t][1];
	if (maxout>=n) return -1;
	
	for (t=0; t<n; t++) {
		S[t] = G[t] = 0;
		lhs += s[t][0];
		rhs += s[t][1];
	}
	G[n] = S[n] = 0;
	
	if (lhs!=rhs) return -1;
	
	G[s[0][1]+1] = 1;
	for (t=1; t<n; t++) {
		G[s[t][1]]++;
		if (s[t][1] >= t+1)  S[s[t][1]]--;
		if (s[t][1]+1 > t+1) S[s[t][1]+1]++;
	}
	
	lhs    = s[0][0];
	rhs    = n-1-G[0];
	gtilde = G[0]+G[1];
	t = 1;
	while (t<n-1 && lhs<=rhs) {
		t++;
		lhs += s[t-1][0];
		rhs += n-gtilde;
		if (s[t-1][1]>=t) rhs--;
		gtilde += G[t]+S[t];
	}
	
	
	if (lhs>rhs) return 0;
	else return 1;
}




/* Lexicographical quicksort */
static void lexqsort(int **s, const int n)
{
	int i, anyone, pivotin, pivotout, l_ind=0, s_ind=0, h_ind=0, **lower, **higher, **same;
	
	
	if (n<=1) return;
	
	lower     = malloc(n*sizeof(int*));
	lower[0]  = calloc(2*n,sizeof(int));
	higher    = malloc(n*sizeof(int*));
	higher[0] = calloc(2*n,sizeof(int));
	same      = malloc(n*sizeof(int*));
	same[0]   = calloc(2*n,sizeof(int));
	for (i=1;i<n;i++) {
		lower[i]  = lower[i-1]+2;
		higher[i] = higher[i-1]+2;
		same[i]   = same[i-1]+2;
	}
	
	anyone = (int) (floor ( ( ( (double) rand() ) / ( (double) RAND_MAX ) ) * (double) n ));
	pivotin  = s[anyone][0];
	pivotout = s[anyone][1];
	
	for (i=0;i<n;i++) {
		if (s[i][0]<pivotin) {
			lower[l_ind][0]   = s[i][0];
			lower[l_ind++][1] = s[i][1];
		} else if (s[i][0]>pivotin) {
			higher[h_ind][0]   = s[i][0];
			higher[h_ind++][1] = s[i][1];
		} else if (s[i][1]<pivotout) {
			lower[l_ind][0]   = s[i][0];
			lower[l_ind++][1] = s[i][1];
		} else if (s[i][1]>pivotout) {
			higher[h_ind][0]   = s[i][0];
			higher[h_ind++][1] = s[i][1];
		} else {
			same[s_ind][0]   = s[i][0];
			same[s_ind++][1] = s[i][1];
		}
	}
	
	lexqsort(lower,l_ind);
	lexqsort(higher,h_ind);
	
	if (h_ind) for (i=0;i<h_ind;i++) {
		s[i][0] = higher[i][0];
		s[i][1] = higher[i][1];
	}
	if (s_ind) for (i=h_ind;i<s_ind+h_ind;i++) {
		s[i][0] = same[i-h_ind][0];
		s[i][1] = same[i-h_ind][1];
	}
	if (l_ind) for (i=s_ind+h_ind;i<h_ind+s_ind+l_ind;i++) {
		s[i][0] = lower[i-h_ind-s_ind][0];
		s[i][1] = lower[i-h_ind-s_ind][1];
	}
	
	free(same[0]);
	free(same);
	free(higher[0]);
	free(higher);
	free(lower[0]);
	free(lower);
	
	
	return;
}




/* Lexicographical quicksort for bds structure*/
static void lexbdsqsort(bds s, const int n)
{
	int i, anyone, pivotin, pivotout, l_ind=0, s_ind=0, h_ind=0;
	bds lower, higher, same;
	
	
	if (n<=1) return;
	
	lower.indegree   = malloc(n*sizeof(int));
	lower.outdegree  = malloc(n*sizeof(int));
	lower.label      = malloc(n*sizeof(int));
	lower.forbidden  = calloc(n,sizeof(int));
	same.indegree    = malloc(n*sizeof(int));
	same.outdegree   = malloc(n*sizeof(int));
	same.label       = malloc(n*sizeof(int));
	same.forbidden   = calloc(n,sizeof(int));
	higher.indegree  = malloc(n*sizeof(int));
	higher.outdegree = malloc(n*sizeof(int));
	higher.label     = malloc(n*sizeof(int));
	higher.forbidden = calloc(n,sizeof(int));
	
	anyone = (int) (floor ( ( ( (double) rand() ) / ( (double) RAND_MAX ) ) * (double) n ));
	pivotin  = s.indegree[anyone];
	pivotout = s.outdegree[anyone];
	
	for (i=0;i<n;i++) {
		if (s.indegree[i]<pivotin) {
			lower.indegree[l_ind]  = s.indegree[i];
			lower.outdegree[l_ind] = s.outdegree[i];
			lower.label[l_ind++]   = s.label[i];
		} else if (s.indegree[i]>pivotin) {
			higher.indegree[h_ind]  = s.indegree[i];
			higher.outdegree[h_ind] = s.outdegree[i];
			higher.label[h_ind++]   = s.label[i];
		} else if (s.outdegree[i]<pivotout) {
			lower.indegree[l_ind]  = s.indegree[i];
			lower.outdegree[l_ind] = s.outdegree[i];
			lower.label[l_ind++]   = s.label[i];
		} else if (s.outdegree[i]>pivotout) {
			higher.indegree[h_ind]  = s.indegree[i];
			higher.outdegree[h_ind] = s.outdegree[i];
			higher.label[h_ind++]   = s.label[i];
		} else {
			same.indegree[s_ind]  = s.indegree[i];
			same.outdegree[s_ind] = s.outdegree[i];
			same.label[s_ind++]   = s.label[i];
		}
	}
	
	lexbdsqsort(lower,l_ind);
	lexbdsqsort(higher,h_ind);
	
	if (h_ind) for (i=0;i<h_ind;i++) {
		s.indegree[i]  = higher.indegree[i];
		s.outdegree[i] = higher.outdegree[i];
		s.label[i]     = higher.label[i];
	}
	if (s_ind) for (i=h_ind;i<s_ind+h_ind;i++) {
		s.indegree[i]  = same.indegree[i-h_ind];
		s.outdegree[i] = same.outdegree[i-h_ind];
		s.label[i]     = same.label[i-h_ind];
	}
	if (l_ind) for (i=s_ind+h_ind;i<h_ind+s_ind+l_ind;i++) {
		s.indegree[i]  = lower.indegree[i-h_ind-s_ind];
		s.outdegree[i] = lower.outdegree[i-h_ind-s_ind];
		s.label[i]     = lower.label[i-h_ind-s_ind];
	}
	
	free(higher.forbidden);
	free(higher.label);
	free(higher.outdegree);
	free(higher.indegree);
	free(same.forbidden);
	free(same.label);
	free(same.outdegree);
	free(same.indegree);
	free(lower.forbidden);
	free(lower.label);
	free(lower.outdegree);
	free(lower.indegree);
	
	
	return;
}




/* My efficient graphicality test */
static int GTest(int *s, const int realn)
{
	int i, n, what, flag=0, k, xk[realn];
	long int degsum=0, minsum, c;
	
	i = realn;
	do i--;
	while (i>=0 && s[i]==0);
	n = i+1;
	
	if (n==0) return 1;
	if (s[0]>=n) return -1;
	
	for (i=0;i<n;i++) degsum += s[i];
	if (degsum%2) what = -1;
	else {
		c = -1;
		
		for (k=n-1; k>=(*s); k--) *(xk+k) = 0;									// Hehehe...
		for (k=1;k<n;k++) for (c=(*(s+k-1))-1; c>=(*(s+k)); c--) *(xk+c)=k;		// Dehihiho
		for (k=c;k>=0;k--) *(xk+k)=n;
		
		degsum = s[0];
		minsum = n-1;
		
		k = 1;
		while (k<n-1 && degsum<=minsum) {										// Test!
	        degsum += s[k];
	        if ((*(xk+k))<k+1) flag=1;
	        if (!flag) minsum += (*(xk+k))-1;
	        else minsum += 2*k-(*(s+k));
	        k++;
	    }
	    
	    if (degsum>minsum) what = 0;
	    else what = 1;
	}
    
    
    return what;
}




static void quicksort(int *s, const int n)
{
	int i, anyone, pivot, l_ind=0, s_ind=0, h_ind=0, *lower, *higher, *same;
	
	
	if (n<=1) return;
	
	lower  = malloc(n*sizeof(int));
	higher = malloc(n*sizeof(int));
	same   = malloc(n*sizeof(int));
	
	anyone = (int) (floor ( ( ( (double) rand() ) / ( (double) RAND_MAX ) ) * (double) n ));
	pivot  = s[anyone];
	
	for (i=0;i<n;i++) {
		if (s[i]<pivot) lower[l_ind++]=s[i];
		else {
			if (s[i]>pivot) higher[h_ind++]=s[i];
			else same[s_ind++]=s[i];
		}
	}
	
	quicksort(lower,l_ind);
	quicksort(higher,h_ind);
	
	if (h_ind) for (i=0;i<h_ind;i++) s[i]=higher[i];
	if (s_ind) for (i=h_ind;i<s_ind+h_ind;i++) s[i]=same[i-h_ind];
	if (l_ind) for (i=s_ind+h_ind;i<h_ind+s_ind+l_ind;i++) s[i]=lower[i-h_ind-s_ind];
	
	free(same);
	free(higher);
	free(lower);
	
	
	return;
}




/* Test graphicality of JDM and populate vector with sizes of degree classes*/
static int testjdm(long int **jdm)
{
	int i, j, stop;
	long int dum;
	
	
	nums[0] = 0;
	stop = 0;
	i = 0;
	while (i<maxdeg && !stop) {
		dum = 0;
		for (j=0; j<maxdeg; j++) dum += jdm[i][j];
		dum += jdm[i][i];
		if (dum%(i+1)) stop = 1;
		else nums[i+1] = dum/(i+1);
		i++;
	}
	
	i = 0;
	while (i<maxdeg && !stop) {
		if (jdm[i][i] > nums[i+1]*(nums[i+1]-1)/2) stop = 1;
		i++;
	}
	i = 0;
	while (i<maxdeg && !stop) {
		j = i+1;
		while (j<maxdeg && !stop) {
			if (jdm[i][j] > nums[i+1]*nums[j+1]) stop = 1;
			j++;
		}
		i++;
	}
	
	
	if (stop) return 0;
	return 1;
}
